;    ,
;    .
;    Microsoft SDK/DDK
EXCEPTION_DEBUG_EVENT		     equ 1
CREATE_THREAD_DEBUG_EVENT	     equ 2
CREATE_PROCESS_DEBUG_EVENT	     equ 3
EXIT_THREAD_DEBUG_EVENT 	     equ 4
EXIT_PROCESS_DEBUG_EVENT	     equ 5
LOAD_DLL_DEBUG_EVENT		     equ 6
UNLOAD_DLL_DEBUG_EVENT		     equ 7
OUTPUT_DEBUG_STRING_EVENT	     equ 8
RIP_EVENT			     equ 9
EXCEPTION_MAXIMUM_PARAMETERS	     equ 15

CONTEXT_i386		  equ 00010000h
CONTEXT_i486		  equ 00010000h
CONTEXT_CONTROL 	  equ CONTEXT_i386 OR 00000001h
CONTEXT_INTEGER 	  equ CONTEXT_i386 OR 00000002h
CONTEXT_SEGMENTS	  equ CONTEXT_i386 OR 00000004h
CONTEXT_FLOATING_POINT	  equ CONTEXT_i386 OR 00000008h
CONTEXT_DEBUG_REGISTERS   equ CONTEXT_i386 OR 00000010h
CONTEXT_FULL		  equ CONTEXT_CONTROL OR CONTEXT_INTEGER OR CONTEXT_SEGMENTS
SIZE_OF_80387_REGISTERS   equ 80
MAXIMUM_SUPPORTED_EXTENSION   equ 512
DBG_CONTINUE			     equ 00010002h
DBG_TERMINATE_THREAD		     equ 40010003h
DBG_TERMINATE_PROCESS		     equ 40010004h
DBG_CONTROL_C			     equ 40010005h
DBG_CONTROL_BREAK		     equ 40010008h
DBG_EXCEPTION_NOT_HANDLED	     equ 80010001h
FLAG_BS 			     equ 4000h
FLAG_TF 			     equ 100h

; :
struct EXCEPTION_RECORD
  ExceptionCode 	dd	?
  ExceptionFlags	dd	?
  pExceptionRecord	dd	?
  ExceptionAddress	dd	?
  NumberParameters	dd	?
  ExceptionInformation	rd EXCEPTION_MAXIMUM_PARAMETERS
ends

struct EXCEPTION_DEBUG_INFO
  pExceptionRecord  EXCEPTION_RECORD
  dwFirstChance     dd	    ?
ends

struct CREATE_THREAD_DEBUG_INFO
  hThread		dd	?
  lpThreadLocalBase	dd	?
  lpStartAddress	dd	?
ends

struct CREATE_PROCESS_DEBUG_INFO
  hFile 		dd	?
  hProcess		dd	?
  hThread		dd	?
  lpBaseOfImage 	dd	?
  dwDebugInfoFileOffset dd	?
  nDebugInfoSize	dd	?
  lpThreadLocalBase	dd	?
  lpStartAddress	dd	?
  lpImageName		dd	?
  fUnicode		dd	? ;   WORD
ends

struct EXIT_THREAD_DEBUG_INFO
  dwExitCode  dd      ?
ends

struct EXIT_PROCESS_DEBUG_INFO
  dwExitCode  dd      ?
ends

struct LOAD_DLL_DEBUG_INFO
  hFile 		    dd	    ?
  lpBaseOfDll		    dd	    ?
  dwDebugInfoFileOffset     dd	    ?
  nDebugInfoSize	    dd	    ?
  lpImageName		    dd	    ?
  fUnicode		    dd	    ? ;   WORD
ends

struct UNLOAD_DLL_DEBUG_INFO
  lpBaseOfDll  dd      ?
ends

struct OUTPUT_DEBUG_STRING_INFO
  lpDebugStringData	dd	?
  fUnicode		dw	?
  nDebugStringiLength	dw	?
ends

struct RIP_INFO
  dwError   dd	    ?
  dwType    dd	    ?
ends

struct DEBUG_EVENT
 dwDebugEventCode  dd ?
 dwProcessId	   dd ?
 dwThreadId	   dd ?
 union
  Exception	    EXCEPTION_DEBUG_INFO
  CreateThread	    CREATE_THREAD_DEBUG_INFO
  CreateProcessInfo CREATE_PROCESS_DEBUG_INFO
  ExitThread	    EXIT_THREAD_DEBUG_INFO
  ExitProcess	    EXIT_PROCESS_DEBUG_INFO
  LoadDll	    LOAD_DLL_DEBUG_INFO
  UnloadDll	    UNLOAD_DLL_DEBUG_INFO
  DebugString	    OUTPUT_DEBUG_STRING_INFO
  RipInfo	    RIP_INFO
 ends
ends


struct FLOATING_SAVE_AREA
  ControlWord	dd	?
  StatusWord	dd	?
  TagWord	dd	?
  ErrorOffset	dd	?
  ErrorSelector dd	?
  DataOffset	dd	?
  DataSelector	dd	?
  RegisterArea	rb  SIZE_OF_80387_REGISTERS
  Cr0NpxState	dd	?
ends

struct CONTEXT
  ContextFlags	dd	?
  iDr0		dd	?
  iDr1		dd	?
  iDr2		dd	?
  iDr3		dd	?
  iDr6		dd	?
  iDr7		dd	?
  FloatSave	FLOATING_SAVE_AREA
  regGs 	dd	?
  regFs 	dd	?
  regEs 	dd	?
  regDs 	dd	?
  regEdi	dd	?
  regEsi	dd	?
  regEbx	dd	?
  regEdx	dd	?
  regEcx	dd	?
  regEax	dd	?
  regEbp	dd	?
  regEip	dd	?
  regCs 	dd	?
  regFlag	dd	?
  regEsp	dd	?
  regSs 	dd	?
  ExtendedRegisters rb MAXIMUM_SUPPORTED_EXTENSION
ends