; Win32-  (ASCII-)
; ( )

include 'macro\struct.inc'
include 'macro\if.inc'
;include 'macro\com32.inc'
include 'macro\import32.inc'
;include 'macro\export32.inc'
;include 'Encoding\win1251.inc'

struc CHAR val { match any, val \{ . db val \}
		 match , val \{ . db ? \} }

include 'equates\kernel32.inc'
include 'equates\user32.inc'


; .for (   .endf  .exitf)
macro .for icnd,wcnd,[chng] {
 ; 
 common
 match v1==v2, icnd \{
  mov v1,v2
 \}
 ;   
 local ..for
 __FOR equ ..for
 local ..endf
 __ENDF equ ..endf
 __CHNG equ chng
 __FOR:
 JNCOND __ENDF,wcnd
}

; 
macro .cndparsex chng {
 common
  match =COND v1++, COND chng \{
   inc	v1
   COND equ
  \}
  match =COND v1--, COND chng \{
   dec	v1
   COND equ
  \}
  match =COND v1+==v2, COND chng \{
   add	v1,v2
   COND equ
  \}
  match =COND v1-==v2, COND chng \{
   sub v1,v2
   COND equ
  \}
  restore COND
}

macro .endf {
 common
  match v1, __CHNG \{
   irp value,v1 \\{
    .cndparsex value
   \\}
  \}
  jmp __FOR
  __ENDF:
  restore __FOR
  restore __ENDF
  restore __CHNG
}

macro JCOND label,[cond]
{
 common
 match =COND v1<v2, COND cond
 \{
   cmp v1,v2
   jb label
   COND equ
 \}
 match =COND v1>v2, COND cond
 \{
   cmp v1,v2
   ja label
   COND equ
 \}
 match =COND v1==v2, COND cond
 \{
   cmp v1,v2
   je label
   COND equ
 \}
 match =COND v1<>v2, COND cond
 \{
   cmp v1,v2
   jne label
   COND equ
 \}
 match =COND v1<==v2, COND cond
 \{
   cmp v1,v2
   jbe label
   COND equ
 \}
 match =COND v1>==v2, COND cond
 \{
   cmp v1,v2
   jae label
   COND equ
 \}
 restore COND
}

;   for
macro .exitf cond {
 JCOND __ENDF,cond
}

;if/case instructions
macro jif op1,cond,op2,label
 {
  cmp op1,op2
  j#cond label
 }

;"" if (  0)
macro .ifz op {
 common
 __IF equ
 local ..endif
 __ENDIF equ ..endif
 local ..else
 __ELSE equ ..else
 test op,op
 jnz __ELSE
}
macro .ifnz op {
 common
 __IF equ
 local ..endif
 __ENDIF equ ..endif
 local ..else
 __ELSE equ ..else
 test op,op
 jz __ELSE
}


macro case op,[num,label] {
 forward
  cmp op,num
  je label
}

macro proc name,[arg]			; define procedure
 { common
    name:
    virtual at ebp+8
    if ~ arg eq
   forward
     local ..arg
     ..arg dd ?
     arg equ ..arg
   common
     end if
     ..ret = $ - (ebp+8)
    end virtual
    local ..dynamic_data,..dynamic_size
    dynamic_data equ ..dynamic_data
    dynamic_size equ ..dynamic_size
    virtual at ebp - dynamic_size
     dynamic_data: }

macro enter				; begin procedure instructions
 { dynamic_size = $ - dynamic_data
   end virtual
   enter dynamic_size,0 }

macro return				; return from procedure
 { leave
   ret ..ret }

macro stdcall proc,[arg]		; call procedure
 { reverse
    pushd arg
   common
    call proc }

macro invoke proc,[arg] 		; invoke procedure (indirect)
 { common
    if ~ arg eq
     stdcall [proc],arg
    else
     call [proc]
    end if }

macro allow_nesting
{ macro pushd value
  \{ match ,value \\{
      pushx equ \\}
     match =pushx =invoke proc,pushx value \\{
      allow_nesting
      invoke proc
      purge pushd,invoke,stdcall,cinvoke,ccall
      push eax
      pushx equ \\}
     match =pushx =stdcall proc,pushx value \\{
      allow_nesting
      stdcall proc
      purge pushd,invoke,stdcall,cinvoke,ccall
      push eax
      pushx equ \\}
     match =pushx,pushx \\{
      pushd <value>
      pushx equ \\}
     restore pushx \}
  macro invoke proc,[arg]
  \{ if ~ arg eq
      \reverse pushd <arg>
     end if
     \common call [proc] \}
  macro stdcall proc,[arg]
  \{ if ~ arg eq
      \reverse pushd <arg>
     end if
     \common call proc \}
}

macro pushd value
{ match pushd =double [var],pushd value \{
   push dword [var+4]
   push dword [var]
   pushd equ \}
  match pushd =double =ptr var,pushd value \{
   push dword [var+4]
   push dword [var]
   pushd equ \}
  match pushd =double num,pushd value \{ \local ..high,..low
   virtual at 0
    dq num
    load ..low dword from 0
    load ..high dword from 4
   end virtual
   push ..high
   push ..low
   pushd equ \}
  match pushd,pushd \{ \local ..continue
   push value
   pushd equ \}
  restore pushd }

allow_nesting

INFINITE equ -1